﻿Imports System.IO
Imports System.Windows.Forms
Imports System.IO.Ports
Imports Strings = Microsoft.VisualBasic ' so can use things like left( and right( for strings
Public Class Form1
    Dim WithEvents SerialPortName As New IO.Ports.SerialPort ' generic serial port
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer) ' for sleep statements
    Public Declare Auto Function SendMessage Lib "user32.dll" (ByVal hWnd As IntPtr, ByVal wMsg As Int32, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr ' disable redrawing of richtextbox etc
    Public Const WM_SETREDRAW As Int32 = &HB ' for above sendmessage
    ' Constants from the Platform SDK to disable richtextbox redraw etc
    Public Const EM_SETEVENTMASK As Integer = 1073
    Public Const EM_GETPARAFORMAT As Integer = 1085
    Public Const EM_SETPARAFORMAT As Integer = 1095
    Public Const EM_SETTYPOGRAPHYOPTIONS As Integer = 1226
    Public Const TO_ADVANCEDTYPOGRAPHY As Integer = 1
    Public Const PFM_ALIGNMENT As Integer = 8
    Public Const SCF_SELECTION As Integer = 1
    ' public variables
    Dim XOut(0 To 133) As Byte ' xmodem output packet
    Dim InPacket(0 To 2000) As Byte ' Major bug with serial.write strings like chr(255) won't go out
    Dim OutPacket(0 To 2000) As Byte
    Public Baud As Int32
    Public SerialPortFound As Boolean = True
    Public ComPort As String
    ' tree view code
    ' http://glassocean.net/how-to-create-a-treeview-file-browser-component-in-vb-net/  for the treeview code
    'Private mRootPath As String = "C:\propeller\centimanes\Multipropfiles"
    Private mRootPath As String = "C:\"
    Property RootPath As String
        Get
            Return mRootPath
        End Get
        Set(ByVal value As String)
            mRootPath = value
        End Set
    End Property

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        End
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' treeview load
        Dim mRootNode As New TreeNode
        mRootNode.Text = RootPath
        mRootNode.Tag = RootPath
        mRootNode.Nodes.Add("*DUMMY*")
        TreeView1.Nodes.Add(mRootNode)

        mRootNode.ImageKey = CacheShellIcon(RootPath)
        mRootNode.SelectedImageKey = mRootNode.ImageKey

        'Dim ScreenWidth, ScreenHeight As Integer
        Me.WindowState = FormWindowState.Maximized ' set to full screen
        'ScreenWidth = Screen.PrimaryScreen.Bounds.Size.Width
        'ScreenHeight = Screen.PrimaryScreen.Bounds.Size.Height
        'Me.Width = ScreenWidth - 200 ' size of the form set by the screen resolution - not needed if set maximised
        'Me.Height = ScreenHeight - 200
        Me.TabControl1.Width = Me.Width - 30 - Me.TabControl1.Location.X ' size of tab control set by the form
        Me.TabControl1.Height = Me.Height - 100

        Me.RichTextBox1.Width = Me.TabControl1.Width - 20 - Me.RichTextBox1.Location.X ' text boxes size set by tab control size
        Me.RichTextBox1.Height = Me.TabControl1.Height - 36 - Me.RichTextBox1.Location.Y
        Me.RichTextBox2.Width = Me.RichTextBox1.Width 'all text boxes the same size
        Me.RichTextBox2.Height = Me.RichTextBox1.Height
        Me.RichTextBox3.Width = Me.RichTextBox1.Width 'all text boxes the same size
        Me.RichTextBox3.Height = Me.RichTextBox1.Height

        TextBox1.Text = mRootPath
        ComPort = "COM6"
        Baud = 115200
        UpdateSettings()

        ' temp for debugging
        'TabControl1.SelectedIndex = 0
        'OpenFile(TextBox1.Text + "\" + "Kyedos3_TV.spin")
        'TabControl1.SelectedIndex = 1
        'OpenFile(TextBox1.Text + "\" + "Bargraph.spin")

    End Sub


    Private Sub TreeView1_BeforeCollapse(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeCollapse
        ' clear the node that is being collapsed
        e.Node.Nodes.Clear()
        ' add a dummy TreeNode to the node being collapsed so it is expandable
        e.Node.Nodes.Add("*DUMMY*")
    End Sub
    Private Sub TreeView1_BeforeExpand(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeExpand
        ' clear the expanding node so we can re-populate it, or else we end up with duplicate nodes
        e.Node.Nodes.Clear()
        ' get the directory representing this node
        Dim mNodeDirectory As IO.DirectoryInfo
        mNodeDirectory = New IO.DirectoryInfo(e.Node.Tag.ToString)

        TextBox1.Text = e.Node.Tag.ToString ' current directory

        ' add each subdirectory from the file system to the expanding node as a child node
        For Each mDirectory As IO.DirectoryInfo In mNodeDirectory.GetDirectories
            ' declare a child TreeNode for the next subdirectory
            Dim mDirectoryNode As New TreeNode
            ' store the full path to this directory in the child TreeNode's Tag property

            mDirectoryNode.ImageKey = CacheShellIcon(mDirectory.FullName) ' add image
            mDirectoryNode.SelectedImageKey = mDirectoryNode.ImageKey

            mDirectoryNode.Tag = mDirectory.FullName
            ' set the child TreeNodes's display text
            mDirectoryNode.Text = mDirectory.Name
            ' add a dummy TreeNode to this child TreeNode to make it expandable
            mDirectoryNode.Nodes.Add("*DUMMY*")
            ' add this child TreeNode to the expanding TreeNode
            e.Node.Nodes.Add(mDirectoryNode)
        Next
        ' add each file from the file system that is a child of the argNode that was passed in
        For Each mFile As IO.FileInfo In mNodeDirectory.GetFiles
            ' declare a TreeNode for this file
            Dim mFileNode As New TreeNode
            ' store the full path to this file in the file TreeNode's Tag property
            mFileNode.Tag = mFile.FullName
            ' set the file TreeNodes's display text
            mFileNode.Text = mFile.Name
            mFileNode.ImageKey = CacheShellIcon(mFile.FullName)
            mFileNode.SelectedImageKey = mFileNode.ImageKey & "-open"
            ' add this file TreeNode to the TreeNode that is being populated
            e.Node.Nodes.Add(mFileNode)
        Next
    End Sub
    Function CacheShellIcon(ByVal argPath As String) As String
        Dim mKey As String = Nothing
        ' determine the icon key for the file/folder specified in argPath
        If IO.Directory.Exists(argPath) = True Then
            mKey = "folder"
        ElseIf IO.File.Exists(argPath) = True Then
            mKey = IO.Path.GetExtension(argPath)
        End If
        ' check if an icon for this key has already been added to the collection
        If ImageList1.Images.ContainsKey(mKey) = False Then
            ImageList1.Images.Add(mKey, GetShellIconAsImage(argPath))
        End If
        Return mKey
    End Function
    Private Sub TreeView1_NodeMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseClick
        ' only proceed if the node represents a file
        If e.Node.ImageKey = "folder" Then Exit Sub
        If e.Node.Tag = "" Then Exit Sub
        ' try to open the file
        Try
            'Process.Start(e.Node.Tag)
            OpenFile(Convert.ToString(e.Node.Tag))
        Catch ex As Exception
            MessageBox.Show("Error opening file: " & ex.Message)
        End Try
    End Sub

    Private Sub OpenFile(ByVal FilenamePath As String)
        Select Case TabControl1.SelectedIndex ' load into the active tab
            Case 0
                RichTextBox1.LoadFile(FilenamePath, RichTextBoxStreamType.PlainText)
                RichTextBox1.Focus()
                TextBox2.Text = GetFilename(FilenamePath)
            Case 1
                RichTextBox2.LoadFile(FilenamePath, RichTextBoxStreamType.PlainText)
                RichTextBox2.Focus()
                TextBox3.Text = GetFilename(FilenamePath)
            Case 2
                RichTextBox3.LoadFile(FilenamePath, RichTextBoxStreamType.PlainText)
                RichTextBox3.Focus()
                TextBox4.Text = GetFilename(FilenamePath)
        End Select
    End Sub
    Private Function GetFilename(ByVal strPath)
        Dim Fname As String
        Fname = Strings.Right(strPath, Strings.Len(strPath) - Strings.InStrRev(strPath, "\"))
        Return Fname
    End Function

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        SaveLoaderAndCompile()
        CompileSlave1()
        CompileMaster()
    End Sub
    Private Sub SaveLoaderAndCompile()
        BSTCompileDownload(Form2.TextBox1.Text)
    End Sub
    Private Sub CompileMaster()
        RichTextBox1.SaveFile(TextBox1.Text + "\" + "Master.spin", RichTextBoxStreamType.PlainText)
        BSTCompileDownload("Master.Spin")
    End Sub
    Private Sub CompileSlave1()
        Dim Pingroup As Integer
        Dim FileSize As Int32
        RichTextBox2.SaveFile(TextBox1.Text + "\" + "Slave1.spin", RichTextBoxStreamType.PlainText)
        BSTCompile("Slave1.Spin")
        Dim FileInformation As New FileInfo(TextBox1.Text + "\" + "Slave1.Binary")
        FileSize = FileInformation.Length
        'MsgBox(Convert.ToString(FileSize))
        Pingroup = Form2.TextBox2.Text
        XModemSend(TextBox1.Text + "\" + "Slave1.Binary", Pingroup, 50) ' send to this pingroup
    End Sub
    Private Sub Delay(ByVal milliseconds As Integer) ' delay with doevents
        Dim i As Integer
        For i = 1 To milliseconds Step 20
            Sleep(18) ' trial and error
            Application.DoEvents()
        Next
    End Sub
    Private Sub BSTCompileDownload(ByVal Filename As String)
        Dim Location As New Process
        Dim i As Integer
        ' Create the batch file
        FileOpen(1, TextBox1.Text + "\Download.bat", OpenMode.Output)
        PrintLine(1, "bstc -b -d " + ComPort + " -p0 " + Filename)
        'PrintLine(1, "Pause")
        PrintLine(1, "Exit") ' so batch file finishes
        FileClose(1)
        ' compile the program
        Location.StartInfo.FileName = "Download.bat"
        Location.StartInfo.WorkingDirectory = TextBox1.Text
        Location.Start() ' shell the file
        Do
            Application.DoEvents() ' need to hand control to the dos window regularly otherwise timing is upset in the download program
            Sleep(10) ' small delay 
        Loop Until Location.HasExited = True ' batch file has finished
    End Sub
    Private Sub BSTCompile(ByVal Filename As String)
        Dim Location As New Process
        ' Create the batch file
        FileOpen(1, TextBox1.Text + "\Compile.bat", OpenMode.Output)
        PrintLine(1, "bstc -b " + Filename)
        'PrintLine(1, "Pause")
        PrintLine(1, "Exit") ' so batch file finishes
        FileClose(1)
        ' compile the program
        Location.StartInfo.FileName = "Compile.bat"
        Location.StartInfo.WorkingDirectory = TextBox1.Text
        Location.Start() ' shell the file
        Do
            Application.DoEvents() ' need to hand control to the dos window regularly otherwise timing is upset in the download program
            Sleep(10) ' small delay 
        Loop Until Location.HasExited = True
    End Sub

    Private Sub SettingsToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem1.Click
        Form2.Show()
    End Sub
    Private Sub UpdateSettings()
        Select Case ComPort
            Case "COM1" : Form2.RadioButton1.Checked = True
            Case "COM2" : Form2.RadioButton2.Checked = True
            Case "COM3" : Form2.RadioButton3.Checked = True
            Case "COM4" : Form2.RadioButton4.Checked = True
            Case "COM5" : Form2.RadioButton5.Checked = True
            Case "COM6" : Form2.RadioButton6.Checked = True
        End Select
    End Sub
    Sub XModemSend(ByRef FName As String, ByVal Pingroup As Int32, ByVal Delay1 As Integer) ' delay of 50 works
        Dim Filenamepath As String
        Dim a, j, i As Integer
        Dim k As Integer
        Dim LineOfText As String
        Dim SerialString As String
        Dim Counter As Integer
        Dim ErrorString As String
        Dim Packetnumber As Integer
        Dim Checksum As Long
        Dim OnesComplement As Byte
        Dim ByteRead As Byte
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long
        Dim Percent As Single
        Dim ErrorCounter As Byte ' 0 to 10
        Dim Timeout As Boolean
        Form3.ProgressBar1.Maximum = 100
        Form3.ProgressBar1.Minimum = 0
        Form3.Show()
        ' timer restart =true for sending via menu. False for auto send
        Filenamepath = FName
        Packetnumber = 1 ' 1 for the first packet (not zero)
        ' Try
        Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
        Dim br As New BinaryReader(Input)
        OpenSerialPort() ' open the serial port
        Form3.Label3.Text = "Error Count"
        Form3.Label2.Text = "0%"
        BinaryFileLength = br.BaseStream.Length() - 1
        ' send setup commmands
        LineOfText = "XM" + vbCr ' wakeup message
        Call StringToPacket(LineOfText) ' send a text message with the file size as a string
        ' text string for size is always 5 bytes eg nnnnn eg SIZE=00080 in decimal
        LineOfText = "SIZE=" + Strings.Right("00000" + Strings.Trim(Strings.Str(BinaryFileLength + 1)), 5) + vbCr
        Call StringToPacket(LineOfText) ' send a text message with the file size as a string
        LineOfText = "PINGROUP=" + Strings.Right("00000" + Strings.Trim(Strings.Str(Pingroup)), 5) + vbCr
        Call StringToPacket(LineOfText) ' send a text message with the file size as a string

        ' xmodem transfer
        Call ClearInputBuffer()  ' clear the buffer into the PC
        Do
            SerialString = ""
            If SerialPortFound = True Then
                If SerialPortName.BytesToRead > 0 Then
                    SerialPortName.Read(InPacket, 0, 1) ' get one byte
                    SerialString = Chr(InPacket(0)) ' get a single character/string/byte
                End If
            End If
            If InPacket(0) = 21 Then
                ErrorString = "NAK"
                Exit Do ' got a ^U
            End If
            If SerialString <> "" Then
                'LineOfText = SerialString
                'Call TextLines(LineOfText) ' print it out unless it is a chr21
            End If
            Counter = Counter + 10
            Sleep(10) ' don't change this one - this is waiting for NAK
            Form3.Label1.Text = "Waiting for NAK to start" + Strings.Str(Counter) + "ms" ' display in milliseconds
            System.Windows.Forms.Application.DoEvents() ' update the label1 message
            ' add a counter and timeout if nothing
            If Counter > 1000 Then
                ErrorString = "Bypass wait for NAK - xmodem failed"
                Exit Do
            End If
            If ErrorString <> "" Then Exit Do
        Loop
        Form3.Label1.Text = ErrorString
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        If ErrorString <> "Bypass wait for NAK - xmodem failed" Then
            Do
                ' act on each byte in the buffer array here
                XOut(0) = 1 'SOH ^A
                XOut(1) = Packetnumber
                OnesComplement = 255 - Packetnumber
                XOut(2) = OnesComplement
                Packetnumber = Packetnumber + 1
                If Packetnumber > 255 Then Packetnumber = Packetnumber - 256
                Checksum = 0
                For i = 0 To 127 ' get 128 bytes from file
                    If BinaryFileCounter <= BinaryFileLength Then
                        ByteRead = br.ReadByte ' get a byte
                    Else
                        ByteRead = 26 ' pad with char 26 = hex 1A because hyperterm does this ? why but it works
                    End If
                    XOut(i + 3) = ByteRead
                    Checksum = Checksum + ByteRead
                    BinaryFileCounter = BinaryFileCounter + 1
                Next
                ' create checksum
                Do
                    If Checksum < 256 Then Exit Do ' work out checksum
                    Checksum = Checksum - 256
                Loop
                XOut(131) = Checksum
                Call OutputXout()
                System.Windows.Forms.Application.DoEvents() ' update the label
                Timeout = False
                Do
                    k = 0
                    Do
                        If SerialPortFound = True Then
                            j = SerialPortName.BytesToRead
                        End If
                        If j >= 1 Then
                            If SerialPortFound = True Then
                                SerialPortName.Read(InPacket, 0, 1) ' get one byte
                            End If
                            Exit Do
                        End If
                        k += 1
                        If k > 5000 Then
                            Timeout = True ' 5 second delay for timeout, must be more than the Rx side timeout
                            Exit Do
                        End If
                        Sleep(1) ' 1ms delay
                    Loop
                    If InPacket(0) = 6 Then Exit Do ' remote got the packet so exit
                    If InPacket(0) = 21 Then
                        ' remote didn't get it so try sending again - does up to 10x
                        ErrorCounter = ErrorCounter + 1
                        Call ClearInputBuffer() ' clear the input buffer to the PC
                        Sleep(1000) ' let the remote get itself sorted before resending the packet
                        Call OutputXout() ' resend the packet
                        Form3.Label3.Text = "Nak: " + Strings.Str(ErrorCounter)
                        System.Windows.Forms.Application.DoEvents() ' update the label
                    End If
                    If Timeout = True Then
                        Form3.Label3.Text = "Timeout waiting for Ack"
                        ErrorCounter = 20 'force an exit now
                        System.Windows.Forms.Application.DoEvents() ' update the label
                    End If
                    If ErrorCounter >= 10 Then Exit Do ' more than 10 errors
                Loop
                If ErrorCounter >= 10 Then
                    Form3.Label1.Text = "10 or more errors - aborting"
                    Form3.Label2.Text = "0%"
                    OutPacket(0) = 24 ' send a ^X cancel
                    If SerialPortFound = True Then
                        SerialPortName.Write(OutPacket, 0, 1) ' send 1 byte
                        OutPacket(0) = 3 ' send a ^C
                        SerialPortName.Write(OutPacket, 0, 1) ' send 1 byte
                    End If
                    Exit Do
                End If
                If BinaryFileCounter > BinaryFileLength Then Exit Do ' finish up
                Form3.Label1.Text = "Sent packet: " + Strings.Str(Packetnumber) + " = OK"
                Percent = BinaryFileCounter / BinaryFileLength
                Percent = Percent * 100
                Percent = Int(Percent)
                Form3.Label2.Text = Strings.Str(Percent) + "%"
                Form3.ProgressBar1.Value = Percent
            Loop
            If ErrorCounter < 10 Then
                OutPacket(0) = 4 ' finish byte
                If SerialPortFound = True Then
                    SerialPortName.Write(OutPacket, 0, 1) ' send 1 byte
                End If
                Form3.Label2.Text = "100%"
                Form3.Label1.Text = "Finished"
                Form3.ProgressBar1.Value = 100 'done
                'Call StringToPacket(vbCrLf) ' back to kyedos
            End If
        End If
        Input.Close()
        Sleep(200) ' wait for next file
        System.Windows.Forms.Application.DoEvents() ' update the labels
        'Catch ex As Exception
        '    Close()
        '    Label1.Text = Filenamepath + " not found"
        '    System.Windows.Forms.Application.DoEvents() ' update the labels
        '    Sleep(1000) ' so time to read message
        'End Try
        SerialPortName.Close() ' close the serial port
        Form3.Close() ' close the download window
    End Sub
    Sub OpenSerialPort()
        SerialPortName.PortName = ComPort
        SerialPortName.BaudRate = Baud ' baud rate
        SerialPortName.Parity = IO.Ports.Parity.None ' no parity
        SerialPortName.DataBits = 8 ' 8 bits
        SerialPortName.StopBits = IO.Ports.StopBits.One ' one stop bit
        SerialPortName.Open() ' open the port
        SerialPortName.DiscardInBuffer() ' clear the input buffer
    End Sub
    Sub ClearInputBuffer()
        ' eg for running pip no need to display all the background information
        Dim BytesToRead As Integer
        Dim i As Integer
        Dim Character As String
        If SerialPortFound = True Then
            Do
                If SerialPortName.BytesToRead = 0 Then Exit Do ' no more bytes
                BytesToRead = SerialPortName.BytesToRead
                If BytesToRead > 2000 Then BytesToRead = 2000
                SerialPortName.Read(InPacket, 0, BytesToRead) ' read in a packet
                For i = 1 To BytesToRead
                    Character = Strings.Chr(InPacket(i - 1))
                    'Call DisplayCharacter(Character)
                Next i
            Loop
        End If
        'Call RedrawDisplay()
        System.Windows.Forms.Application.DoEvents() ' update the display
    End Sub
    Sub OutputXout() ' uses xout() array and sends it out in pieces of 30 bytes
        ' in a subroutine so resends are easier - passing subroutine fills up the bytes
        ' 1. an SOH byte                             {1 byte}
        ' 2. the packet number                       {1 byte}
        ' 3:      .the(1) 's complement of the packet number {1 byte}
        ' 4. the packet                            {128 bytes}
        ' 5. the checksum                            {1 byte}

        'The following terms are simply ascii codes:
        'SOH = chr(1)  = CTRL-A =
        'EOT = chr(4)  = CTRL-D = End of Transmission
        'ACK = chr(6)  = CTRL-F = Positive Acknowledgement
        'NAK = chr(21) = CTRL-U = Negative Acknowledgement
        'CAN = Chr(24) = CTRL - X = Cancel
        'The packet number sent is simply the number of the packet.  If the packet
        'number is greater than 255, then subtract 256 repeatly until the number is
        'between 0 and 255.  For example, if you were sending packet 731, then you
        'would send 731 - 256 - 256 = 219.
        'The(1) 's complement of a byte (to make life easy) is simply 255 minus the
        'byte.  For example, if you had to take the 1's complement of 142, the answer
        'would be 255 - 142 = 133.

        'The checksum is the value of all the bytes in the packet added together.  For
        'example, if the first five bytes were 45, 12, 64, 236, 173 and the other 123
        'bytes were zeroes, the checksum would be 45+12+64+236+173+0+0+...+0 = 530.
        'However, to make each block one byte smaller, they repeatly subtract 256
        'from the checksum until it is between 0 and 255.  In this case, the checksum
        'would be 530 - 256 - 256 = 18.
        'The(downloader)

        '1. ensures that the packet number sent matches the actual packet number
        'that it is (If the third block send has a '4' as the second byte,
        'something is wrong --> CANCEL TRANSFER (send CAN byte))
        '2. adds the packet number and the 1's complement of it together to make
        'sure that they add up to 255.  if they don't --> CANCEL TRANSFER
        '3. adds up all the bytes in the packet together --> THE SUM
        '4. compares the last two significant digits of THE SUM with the checksum
        '5. if everything looks ok (sum=checksum), then the downloader appends the
        'bytes in the packet to the file being created (sent).  The down-
        'loader then sends an ACK byte which tells the uploader to send the
        'next block.
        'if the sums do not match then the downloader sends an NAK byte which
        'tells the uploader to send the same block it just sent over again.

        ' send in blocks of 30 bytes to keep the Hope module happy
        ' removed the 30 byte block for the moment, hope modules go via boards not pc to board
        Dim i As Integer
        For i = 0 To 131
            OutPacket(i) = XOut(i)
        Next
        If SerialPortFound = True Then
            SerialPortName.Write(OutPacket, 0, 132)
        End If
        ' very slow code to catch bugs etc

        'Dim lineoftext As String
        'For i = 0 To 131
        ' OutPacket(0) = XOut(i)
        ' SerialPortname.Write(OutPacket, 0, 1)
        ' lineoftext = Chr(XOut(i)) ' + "  " + Str(XOut(i))
        ' Call DisplayCharacter(lineoftext)
        ' Call RedrawDisplay()
        ' System.Windows.Forms.Application.DoEvents()
        ' Sleep(100)
        ' Next

    End Sub
    Sub StringToPacket(ByVal lineoftext As String)
        ' send a string out, but don't use for data as numbers like 255 don't work
        ' also don't go over 30 (CPM commands never would be)
        Dim i As Byte
        Dim PacketLength As Byte
        Dim TypematicDelay As Integer
        Dim Character As String
        PacketLength = Strings.Len(lineoftext)
        'TypematicDelay = 10 ' anything under 50 misses characters on MPM
        ' seems to be more reliable with timer off (Sept 2010)
        ' 120 for 4800 baud don't go too short otherwise errors, errors at 60 for instance at 4800
        ' errors below 10 at 38400 baud
        ' needs 60 to send and 60 to get character back, so slow but it works
        ' comment - for some reason at wired 38400 we need the slow speed yet can send out as a whole string for radio at 1200?
        Sleep(TypematicDelay) ' typematic delay - depends on clock as much as baud rate
        For i = 1 To PacketLength
            OutPacket(0) = Strings.Asc(Strings.Mid(lineoftext, i, 1))
            If SerialPortFound = True Then
                SerialPortName.Write(OutPacket, 0, 1)
            End If
            'Sleep(TypematicDelay)
            ClearInputBuffer() ' gobble up return bytes
            System.Windows.Forms.Application.DoEvents() ' update the display
        Next
        Sleep(10)
        System.Windows.Forms.Application.DoEvents() ' update the display
    End Sub
    Sub ResetPropeller()
        SerialPortName.PortName = ComPort
        SerialPortName.Open()
        SerialPortName.DtrEnable = False
        SerialPortName.DtrEnable = True ' toggle the dtr line
        SerialPortName.DtrEnable = False
        SerialPortName.Close()
    End Sub
    Private Sub ColorSpin(ByVal TextBoxNumber As Integer)
        Dim Greenwords As New List(Of String)
        Dim Bluewords As New List(Of String)
        Dim Goldwords As New List(Of String) ' syntax errors
        Dim Purplewords As New List(Of String)
        Dim i As Integer
        Dim NumberLines As Integer
        Dim StartLine As Integer
        Dim EndLine As Integer
        Dim LineOfText As String
        Dim CurrentColor As New Color
        Dim PubPri As Boolean

        Dim Tbox As New RichTextBox
        Select Case TextBoxNumber
            Case 1 : Tbox = RichTextBox1
            Case 2 : Tbox = RichTextBox2
            Case 3 : Tbox = RichTextBox3
        End Select

        ' http://condor.depaul.edu/sjost/it236/documents/colorNames.htm
        ' purple words
        Purplewords.Add("FILE")
        'Goldwords.Add(" as ") ' should use =
        SendMessage(Tbox.Handle, WM_SETREDRAW, New IntPtr(CInt(False)), IntPtr.Zero) ' disable refresh
        Dim selectStart As Integer = Tbox.SelectionStart ' preserve cursor
        NumberLines = Tbox.Lines.Length
        'CurrentColor = Color.Black
        'do blue words
        ' can't change the background, as only changes the background where there is text
        CurrentColor = Color.Orange ' start with the comments color
        For i = 0 To NumberLines - 1
            LineOfText = Tbox.Lines(i)
            Select Case Strings.Left(LineOfText, 3)
                Case "CON" : CurrentColor = Color.Orange
                Case "OBJ" : CurrentColor = Color.Firebrick
                Case "PUB", "PRI"
                    If PubPri = True Then
                        CurrentColor = Color.Navy
                        PubPri = False
                    Else
                        CurrentColor = Color.MediumBlue
                        PubPri = True
                    End If
                Case "VAR" : CurrentColor = Color.Tomato
            End Select
            StartLine = Tbox.GetFirstCharIndexFromLine(i) ' start of the line
            EndLine = Tbox.GetFirstCharIndexFromLine(i + 1) ' end of the line
            If EndLine = -1 Then EndLine = Tbox.TextLength ' otherwise problems with the last line (or worse, whole textbox color)
            Tbox.Select(StartLine, EndLine - StartLine)
            Tbox.SelectionColor = CurrentColor
        Next
        Tbox.SelectionStart = selectStart ' restore cursor
        Tbox.SelectionLength = 0
        SendMessage(Tbox.Handle, WM_SETREDRAW, New IntPtr(CInt(True)), IntPtr.Zero) ' restore cursor
        Tbox.Refresh()
    End Sub

    Private Sub ColorCodeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ColorCodeToolStripMenuItem.Click
        ColorSpin(TabControl1.SelectedIndex + 1) ' highlight the current textbox
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        'Save all files

        If RichTextBox1.Text <> "" Then
            RichTextBox1.SaveFile(TextBox1.Text + "\" + TextBox2.Text, RichTextBoxStreamType.PlainText)
        End If
        If RichTextBox2.Text <> "" Then
            RichTextBox2.SaveFile(TextBox1.Text + "\" + TextBox3.Text, RichTextBoxStreamType.PlainText)
        End If
        If RichTextBox3.Text <> "" Then
            RichTextBox3.SaveFile(TextBox1.Text + "\" + TextBox4.Text, RichTextBoxStreamType.PlainText)
        End If
    End Sub
End Class
